﻿using Npgsql;

namespace database
{
    public class Implementation : Abstractions
    {
        private NpgsqlConnection GetConnection()
        {
            return new NpgsqlConnection("Host=172.18.241.131;Username=tim;Database=carrent;");
        }

        // CDUD операции для каждой сущности

        // Car
        public override void AddCar(Car car)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("INSERT INTO car (model_id, branch_id, year, mileage, status_id) VALUES (@ModelId, @BranchId, @Year, @Mileage, @StatusId)", conn);
            cmd.Parameters.AddWithValue("@ModelId", car.ModelId);
            cmd.Parameters.AddWithValue("@BranchId", car.BranchId);
            cmd.Parameters.AddWithValue("@Year", car.Year);
            cmd.Parameters.AddWithValue("@Mileage", car.Mileage);
            cmd.Parameters.AddWithValue("@StatusId", car.StatusId);
            cmd.ExecuteNonQuery(); 
        }

        public override List<Car> GetCars()
        {
            var cars = new List<Car>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM car", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                cars.Add(new Car
                {
                    Id = reader.GetInt32(0),
                    ModelId = reader.GetInt32(1),
                    BranchId = reader.GetInt32(2),
                    StatusId = reader.GetInt32(3),
                    Year = reader.GetInt32(4),
                    Mileage = reader.GetInt32(5),
                });
            }
            return cars;
        }

        public override Car GetCarById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM car WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new Car
                {
                    Id = reader.GetInt32(0),
                    ModelId = reader.GetInt32(1),
                    BranchId = reader.GetInt32(2),
                    StatusId = reader.GetInt32(3),
                    Year = reader.GetInt32(4),
                    Mileage = reader.GetInt32(5),
                };
            }
            return null;
        }

        public override void UpdateCar(Car car)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE car SET model_id = {car.ModelId}, branch_id = {car.BranchId}, year = {car.Year}, mileage = {car.Mileage}, status_id = {car.StatusId} WHERE id = {car.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteCar(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM car WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // Client
        public override void AddClient(Client client)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("INSERT INTO client (name, surname, address, phone, email) VALUES (@Name, @Surname, @Address, @Phone, @Email)", conn);
            cmd.Parameters.AddWithValue("@Name", client.Name);
            cmd.Parameters.AddWithValue("@Surname", client.Surname);
            cmd.Parameters.AddWithValue("@Address", client.Address);
            cmd.Parameters.AddWithValue("@Phone", client.Phone);
            cmd.Parameters.AddWithValue("@Email", client.Email);
            cmd.ExecuteNonQuery();
        }

        public override List<Client> GetClients()
        {
            var clients = new List<Client>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM client", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                clients.Add(new Client
                {
                    Id = reader.GetInt32(0),
                    Name = reader.GetString(1),
                    Surname = reader.GetString(2),
                    Address = reader.GetString(3),
                    Phone = reader.GetString(4),
                    Email = reader.GetString(5)
                });
            }
            return clients;
        }

        public override Client GetClientById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM client WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new Client
                {
                    Id = reader.GetInt32(0),
                    Name = reader.GetString(1),
                    Surname = reader.GetString(2),
                    Address = reader.GetString(3),
                    Phone = reader.GetString(4),
                    Email = reader.GetString(5)
                };
            }
            return null;
        }

        public override void UpdateClient(Client client)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE client SET name = '{client.Name}', surname = '{client.Surname}', address = '{client.Address}', phone = '{client.Phone}', email = '{client.Email}' WHERE id = {client.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteClient(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM client WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // Rental
        public override void AddRental(Rental rental)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("INSERT INTO rental (car_id, client_id, start_date, end_date, cost) VALUES (@CarId, @ClientId, @StartDate, @EndDate, @Cost)", conn);
            cmd.Parameters.AddWithValue("@CarId", rental.CarId);
            cmd.Parameters.AddWithValue("@ClientId", rental.ClientId);
            cmd.Parameters.AddWithValue("@StartDate", rental.StartDate);
            cmd.Parameters.AddWithValue("@EndDate", rental.EndDate);
            cmd.Parameters.AddWithValue("@Cost", rental.Cost);
            cmd.ExecuteNonQuery();
        }

        public override List<Rental> GetRentals()
        {
            var rentals = new List<Rental>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM rental", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                rentals.Add(new Rental
                {
                    Id = reader.GetInt32(0),
                    CarId = reader.GetInt32(1),
                    ClientId = reader.GetInt32(2),
                    StartDate = reader.GetDateTime(3),
                    EndDate = reader.GetDateTime(4),
                    Cost = reader.GetDecimal(5)
                });
            }
            return rentals;
        }

        public override Rental GetRentalById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM rental WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new Rental
                {
                    Id = reader.GetInt32(0),
                    CarId = reader.GetInt32(1),
                    ClientId = reader.GetInt32(2),
                    StartDate = reader.GetDateTime(3),
                    EndDate = reader.GetDateTime(4),
                    Cost = reader.GetDecimal(5)
                };
            }
            return null;
        }

        public override void UpdateRental(Rental rental)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE rental SET car_id = {rental.CarId}, client_id = {rental.ClientId}, start_date = '{rental.StartDate}', end_date = '{rental.EndDate}', cost = {rental.Cost} WHERE id = {rental.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteRental(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM rental WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // CarModel
        public override void AddCarModel(CarModel carModel)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("INSERT INTO car_model (brand, model, year, body_type_id, seats) VALUES (@Brand, @Model, @Year, @BodyTypeId, @Seats)", conn);
            cmd.Parameters.AddWithValue("@Brand", carModel.Brand);
            cmd.Parameters.AddWithValue("@Model", carModel.Model);
            cmd.Parameters.AddWithValue("@Year", carModel.Year);
            cmd.Parameters.AddWithValue("@BodyTypeId", carModel.BodyTypeId);
            cmd.Parameters.AddWithValue("@Seats", carModel.Seats);
            cmd.ExecuteNonQuery();
        }

        public override List<CarModel> GetCarModels()
        {
            var carModels = new List<CarModel>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM car_model", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                carModels.Add(new CarModel
                {
                    Id = reader.GetInt32(0),
                    Brand = reader.GetString(1),
                    Model = reader.GetString(2),
                    Year = reader.GetInt32(3),
                    BodyTypeId = reader.GetInt32(4),
                    Seats = reader.GetInt32(5)
                });
            }
            return carModels;
        }

        public override CarModel GetCarModelById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM car_model WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new CarModel
                {
                    Id = reader.GetInt32(0),
                    Brand = reader.GetString(1),
                    Model = reader.GetString(2),
                    Year = reader.GetInt32(3),
                    BodyTypeId = reader.GetInt32(4),
                    Seats = reader.GetInt32(5)
                };
            }
            return null;
        }
        public override void UpdateCarModel(CarModel carModel)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE car_model SET brand = '{carModel.Brand}', model = '{carModel.Model}', year = {carModel.Year}, body_type_id = {carModel.BodyTypeId}, seats = {carModel.Seats} WHERE id = {carModel.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteCarModel(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM car_model WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // Branch
        public override void AddBranch(Branch branch)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("INSERT INTO branch (name, address, phone, working_hours) VALUES (@Name, @Address, @Phone, @WorkingHours)", conn);
            cmd.Parameters.AddWithValue("@Name", branch.Name);
            cmd.Parameters.AddWithValue("@Address", branch.Address);
            cmd.Parameters.AddWithValue("@Phone", branch.Phone);
            cmd.Parameters.AddWithValue("@WorkingHours", branch.WorkingHours);
            cmd.ExecuteNonQuery();
        }

        public override List<Branch> GetBranches()
        {
            var branches = new List<Branch>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM branch", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                branches.Add(new Branch
                {
                    Id = reader.GetInt32(0),
                    Name = reader.GetString(1),
                    Address = reader.GetString(2),
                    Phone = reader.GetString(3),
                    WorkingHours = reader.GetString(4)
                });
            }
            return branches;
        }

        public override Branch GetBranchById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM branch WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new Branch
                {
                    Id = reader.GetInt32(0),
                    Name = reader.GetString(1),
                    Address = reader.GetString(2),
                    Phone = reader.GetString(3),
                    WorkingHours = reader.GetString(4)
                };
            }
            return null;
        }

        public override void UpdateBranch(Branch branch)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE branch SET name = '{branch.Name}', address = '{branch.Address}', phone = '{branch.Phone}', working_hours = '{branch.WorkingHours}' WHERE id = {branch.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteBranch(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM branch WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // Status
        public override void AddStatus(Status status)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"INSERT INTO status (title) VALUES ('{status.Title}')", conn);
            cmd.ExecuteNonQuery();
        }

        public override List<Status> GetStatuses()
        {
            var statuses = new List<Status>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM status", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                statuses.Add(new Status
                {
                    Id = reader.GetInt32(0),
                    Title = reader.GetString(1)
                });
            }
            return statuses;
        }

        public override Status GetStatusById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM status WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new Status
                {
                    Id = reader.GetInt32(0),
                    Title = reader.GetString(1)
                };
            }
            return null;
        }

        public override void UpdateStatus(Status status)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE status SET title = '{status.Title}' WHERE id = {status.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteStatus(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM status WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }

        // BodyType
        public override void AddBodyType(BodyType bodyType)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"INSERT INTO body_type (title) VALUES ('{bodyType.Title}')", conn);
            cmd.ExecuteNonQuery();
        }

        public override List<BodyType> GetBodyTypes()
        {
            var bodyTypes = new List<BodyType>();
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand("SELECT * FROM body_type", conn);
            using var reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                bodyTypes.Add(new BodyType
                {
                    Id = reader.GetInt32(0),
                    Title = reader.GetString(1)
                });
            }
            return bodyTypes;
        }

        public override BodyType GetBodyTypeById(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"SELECT * FROM body_type WHERE id = {id}", conn);
            using var reader = cmd.ExecuteReader();
            if (reader.Read())
            {
                return new BodyType
                {
                    Id = reader.GetInt32(0),
                    Title = reader.GetString(1)
                };
            }
            return null;
        }

        public override void UpdateBodyType(BodyType bodyType)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"UPDATE body_type SET title = '{bodyType.Title}' WHERE id = {bodyType.Id}", conn);
            cmd.ExecuteNonQuery();
        }

        public override void DeleteBodyType(int id)
        {
            using var conn = GetConnection();
            conn.Open();
            using var cmd = new NpgsqlCommand($"DELETE FROM body_type WHERE id = {id}", conn);
            cmd.ExecuteNonQuery();
        }
    }
}
